From 4c4b550aede3ef0a38167b03061efbee796a0ca6 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:14 +0000
Subject: [PATCH 415/2232] Eliminate unnecessary ToTypename trait


---

diff --git a/gen/write.rs b/gen/write.rs
index 153b5b3..42352d0 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -4,7 +4,7 @@ use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::mangled::ToMangled;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::symbol::Symbol;
-use crate::syntax::typename::ToTypename;
+use crate::syntax::typename::to_typename;
 use crate::syntax::{mangle, Api, ExternFn, ExternType, Signature, Struct, Type, Types, Var};
 use proc_macro2::Ident;
 use std::collections::HashMap;
@@ -978,7 +978,7 @@ fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {
 }
 
 fn write_rust_vec_extern(out: &mut OutFile, ty: &Type) {
-    let inner = ty.to_typename(&out.namespace);
+    let inner = to_typename(&out.namespace, ty);
     let instance = ty.to_mangled(&out.namespace);
 
     writeln!(out, "#ifndef CXXBRIDGE02_RUST_VEC_{}", instance);
@@ -1017,7 +1017,7 @@ fn write_rust_box_impl(out: &mut OutFile, ident: &Ident) {
 }
 
 fn write_rust_vec_impl(out: &mut OutFile, ty: &Type) {
-    let inner = ty.to_typename(&out.namespace);
+    let inner = to_typename(&out.namespace, ty);
     let instance = ty.to_mangled(&out.namespace);
 
     writeln!(out, "template <>");
@@ -1037,7 +1037,7 @@ fn write_rust_vec_impl(out: &mut OutFile, ty: &Type) {
 
 fn write_unique_ptr(out: &mut OutFile, ty: &Type, types: &Types) {
     out.include.utility = true;
-    let inner = ty.to_typename(&out.namespace);
+    let inner = to_typename(&out.namespace, ty);
     let instance = ty.to_mangled(&out.namespace);
 
     writeln!(out, "#ifndef CXXBRIDGE02_UNIQUE_PTR_{}", instance);
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index d1aa638..720680d 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -2,7 +2,7 @@ use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::mangled::ToMangled;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::symbol::Symbol;
-use crate::syntax::typename::ToTypename;
+use crate::syntax::typename::to_typename;
 use crate::syntax::{
     self, check, mangle, Api, ExternFn, ExternType, Signature, Struct, Type, Types,
 };
@@ -573,7 +573,7 @@ fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStre
 }
 
 fn expand_unique_ptr(namespace: &Namespace, ty: &Type, types: &Types) -> TokenStream {
-    let name = ty.to_typename(namespace);
+    let name = to_typename(namespace, ty);
     let inner = ty;
     let mangled = ty.to_mangled(namespace) + "$";
     let prefix = format!("cxxbridge02$unique_ptr${}", mangled);
diff --git a/syntax/typename.rs b/syntax/typename.rs
index b4261f9..9732d32 100644
--- a/syntax/typename.rs
+++ b/syntax/typename.rs
@@ -1,37 +1,31 @@
 use crate::syntax::namespace::Namespace;
 use crate::syntax::{Atom, Type};
 
-pub trait ToTypename {
-    fn to_typename(&self, namespace: &Namespace) -> String;
-}
-
-impl ToTypename for Type {
-    fn to_typename(&self, namespace: &Namespace) -> String {
-        match self {
-            Type::Ident(ident) => {
-                let mut inner = String::new();
-                // Do not apply namespace to built-in type
-                let is_user_type = Atom::from(ident).is_none();
-                if is_user_type {
-                    for name in namespace {
-                        inner += name;
-                        inner += "::";
-                    }
+pub fn to_typename(namespace: &Namespace, ty: &Type) -> String {
+    match ty {
+        Type::Ident(ident) => {
+            let mut inner = String::new();
+            // Do not apply namespace to built-in type
+            let is_user_type = Atom::from(ident).is_none();
+            if is_user_type {
+                for name in namespace {
+                    inner += name;
+                    inner += "::";
                 }
-                if let Some(ti) = Atom::from(ident) {
-                    inner += ti.to_cxx();
-                } else {
-                    inner += &ident.to_string();
-                };
-                inner
             }
-            Type::RustBox(ptr) => format!("rust_box<{}>", ptr.inner.to_typename(namespace)),
-            Type::RustVec(ptr) => format!("rust_vec<{}>", ptr.inner.to_typename(namespace)),
-            Type::UniquePtr(ptr) => {
-                format!("::std::unique_ptr<{}>", ptr.inner.to_typename(namespace))
-            }
-            Type::CxxVector(ptr) => format!("::std::vector<{}>", ptr.inner.to_typename(namespace)),
-            _ => unimplemented!(),
+            if let Some(ti) = Atom::from(ident) {
+                inner += ti.to_cxx();
+            } else {
+                inner += &ident.to_string();
+            };
+            inner
+        }
+        Type::RustBox(ptr) => format!("rust_box<{}>", to_typename(namespace, &ptr.inner)),
+        Type::RustVec(ptr) => format!("rust_vec<{}>", to_typename(namespace, &ptr.inner)),
+        Type::UniquePtr(ptr) => {
+            format!("::std::unique_ptr<{}>", to_typename(namespace, &ptr.inner))
         }
+        Type::CxxVector(ptr) => format!("::std::vector<{}>", to_typename(namespace, &ptr.inner)),
+        _ => unimplemented!(),
     }
 }

